Module MdlMain

    Private mConsoleHeader As String

    '    Function Main(ByVal pArgs As String()) As Integer
    Sub Main(ByVal pArgs As String())
        mConsoleHeader = Console.Title
        mConsoleHeader = "Attrib " + String.Join(" ", pArgs)
#If DEBUG Then
        Console.WriteLine("Attrib """ + String.Join(""" """, pArgs) + """")
#End If

        Dim lOr As IO.FileAttributes = 0
        Dim lAnd As IO.FileAttributes = 0
        Dim lDirectory As Boolean = False
        Dim lSubDir As Boolean = False
        Dim lFile As String = "*"
        Dim lPath As String = "."
        '[+R | -R] [+A | -A ] [+S | -S] [+H | -H] [+C | -C] [+E | -E] [+I | -I] [[lect:] [chemin] fichier] [/S [/D]]
        For Each lStr As String In pArgs
            Select Case lStr.ToLower
                Case "+r"
                    lOr = lOr Or IO.FileAttributes.ReadOnly
                Case "-r"
                    lAnd = lAnd Or IO.FileAttributes.ReadOnly
                Case "+a"
                    lOr = lOr Or IO.FileAttributes.Archive
                Case "-a"
                    lAnd = lAnd Or IO.FileAttributes.Archive
                Case "+s"
                    lOr = lOr Or IO.FileAttributes.System
                Case "-s"
                    lAnd = lAnd Or IO.FileAttributes.System
                Case "+h"
                    lOr = lOr Or IO.FileAttributes.Hidden
                Case "-h"
                    lAnd = lAnd Or IO.FileAttributes.Hidden
                Case "+c"
                    lOr = lOr Or IO.FileAttributes.Compressed
                Case "-c"
                    lAnd = lAnd Or IO.FileAttributes.Compressed
                Case "+e"
                    lOr = lOr Or IO.FileAttributes.Encrypted
                Case "-e"
                    lAnd = lAnd Or IO.FileAttributes.Encrypted
                Case "+i"
                    lAnd = lAnd Or IO.FileAttributes.NotContentIndexed
                Case "-i"
                    lOr = lOr Or IO.FileAttributes.NotContentIndexed
                Case "/s"
                    lSubDir = True
                Case "/d"
                    lDirectory = True
                Case "/?", "-?"
                    ShowHelp()
                    Return
                    'Case "/enr:add"
                    '    'HKEY_LOACL_MACHINE/SOFTWARE/Microsoft/Windows/CurrentVersion/App paths/NomAppExe, Default=ProgPath+ExeName
                    '    Try
                    '        My.Computer.Registry.SetValue("HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\App paths\Attrib.exe", "", IO.Path.Combine(My.Application.Info.DirectoryPath, My.Application.Info.AssemblyName + ".exe"))
                    '        Console.WriteLine("ATTRIB est bien enregistre")
                    '    Catch ex As Exception
                    '        Console.WriteLine("Exception lors de l'inscription de attrib : {0}", ex.Message)
                    '    End Try
                    '    Return
                    'Case "/enr:rmv"
                    '    'HKEY_LOCAL_MACHINE/SOFTWARE/Microsoft/Windows/CurrentVersion/App paths/NomAppExe, Default=ProgPath+ExeName
                    '    Dim lStack As New Stack(Of Microsoft.Win32.RegistryKey)
                    '    Try
                    '        lStack.Push(My.Computer.Registry.LocalMachine)
                    '        lStack.Push(lStack.Peek.OpenSubKey("SOFTWARE"))
                    '        lStack.Push(lStack.Peek.OpenSubKey("Microsoft"))
                    '        lStack.Push(lStack.Peek.OpenSubKey("Windows"))
                    '        lStack.Push(lStack.Peek.OpenSubKey("CurrentVersion"))
                    '        lStack.Push(lStack.Peek.OpenSubKey("App paths", True))
                    '        lStack.Peek.DeleteSubKey("Attrib.exe")
                    '        Console.WriteLine("ATTRIB est bien retaure")
                    '    Catch ex As Exception
                    '        Console.WriteLine("Exception lors de la desinscription de attrib : {0}", ex) ' ex.Message)
                    '    End Try
                    '    Do While lStack.Count > 0
                    '        Dim lReg As Microsoft.Win32.RegistryKey = lStack.Pop
                    '        If lReg IsNot Nothing Then lReg.Close()
                    '    Loop
                    '    Return
                Case Else
                    If lPath.Length > 0 And lPath <> "." Then
                        ShowHelp()
                        Return
                    End If
                    If lStr.Contains("\") Then
                        Dim ltStr As String() = lStr.Split("\"c)
                        lFile = ltStr(ltStr.Length - 1)
                        Dim lLst As New List(Of String)
                        lLst.AddRange(ltStr)
                        lLst.RemoveAt(lLst.Count - 1)
                        lStr = String.Join(IO.Path.DirectorySeparatorChar, lLst.ToArray)
                        'Analyse si nom de dossier incorrecte
                        For Each lChar As Char In IO.Path.GetInvalidPathChars
                            If lStr.Contains(lChar) Then
                                ShowHelp()
                                Return
                            End If
                        Next
                        lPath = IO.Path.GetFullPath(lStr + "\")
                        If lFile = "*.*" Then lFile = ""
                        If IO.Directory.Exists(IO.Path.Combine(lPath, lFile)) Then
                            lPath = IO.Path.Combine(lPath, lFile)
                            lFile = ""
                        End If
                    Else
                        lPath = IO.Path.GetFullPath(".")
                        If lStr <> "*.*" Then lFile = lStr
                    End If
            End Select
        Next

        Analyse(lOr, lAnd, lDirectory, lSubDir, lFile, lPath)


        'IO.Path.GetFullPath(mParam.Path)
        'IO.File.GetAttributes()
        'HKEY_LOACL_MACHINE/SOFTWARE/Microsoft/Windows/CurrentVersion/App paths/NomAppExe, Default=ProgPath+ExeName


#If DEBUG Then
        Console.ReadKey()
#End If
        Console.Title = mConsoleHeader
    End Sub

    Private Sub ShowHelp()
        Console.Write(My.Resources.Help)
#If DEBUG Then
        Console.ReadKey()
#End If
        Console.Title = mConsoleHeader
    End Sub


    Private Sub Analyse(ByVal lOr As IO.FileAttributes, ByVal lAnd As IO.FileAttributes, ByVal lDirectory As Boolean, ByVal lSubDir As Boolean, ByVal lFile As String, ByVal lPath As String)

        Dim lLstDir As New Stack(Of String)

        lLstDir.Push(lPath)

        Do While lLstDir.Count > 0
            lPath = lLstDir.Pop

            'Application des modifs au dossier
            If lDirectory Then
                Dim lDir As New IO.DirectoryInfo(lPath)
                Try
                    lDir.Attributes = (lDir.Attributes Or lOr) And Not (lAnd)
                    If (lOr And IO.FileAttributes.Compressed) <> 0 Then
                        NTInternalCompression.CompressDirectory(lDir.FullName, False)
                    ElseIf (lAnd And IO.FileAttributes.Compressed) <> 0 Then
                        NTInternalCompression.UnCompressFile(lDir.FullName)
                    End If
                Catch ex As Exception
                    Console.WriteLine("Exception lors de la modification des attributs de ""{0}"" : {1}", lDir.FullName, ex.Message)
                End Try
            End If

            Try
                'Parcours des sous dossiers
                If lSubDir Then
                    For Each lDir As String In IO.Directory.GetDirectories(lPath)
                        lLstDir.Push(lDir)
                    Next
                End If
            Catch ex As Exception
                Console.WriteLine("Exception lors de l'accs  ""{0}"" : {1}", lPath, ex.Message)
                Continue Do
            End Try

            'Application des modifs aux fichiers
            Dim lFiles As String()
            If lFile.Length = 0 Then
                lFiles = IO.Directory.GetFiles(lPath)
            Else
                lFiles = IO.Directory.GetFiles(lPath, lFile)
            End If

            For Each lDir As String In lFiles
                ShowAttr(lDir)
                Try
                    If lOr <> lAnd Then
                        IO.File.SetAttributes(lDir, (IO.File.GetAttributes(lDir) Or lOr) And Not (lAnd))
                        If (lOr And IO.FileAttributes.Compressed) <> 0 Then
                            NTInternalCompression.CompressFile(lDir)
                        ElseIf (lAnd And IO.FileAttributes.Compressed) <> 0 Then
                            NTInternalCompression.UnCompressFile(lDir)
                        End If
                    End If
                Catch ex As Exception
                    Console.WriteLine("Exception lors de la modification des attributs de ""{0}"" : {1}", lDir, ex.Message)
                End Try
            Next
        Loop
    End Sub

    Private Sub ShowAttr(ByVal pFileName As String)
        Dim lStr As String = ""
        Dim lAttr As IO.FileAttributes
        lStr = ""
        lAttr = IO.File.GetAttributes(pFileName)
        If (lAttr And IO.FileAttributes.Archive) > 0 Then
            lStr += "A"
        Else
            lStr += " "
        End If
        If (lAttr And IO.FileAttributes.ReadOnly) > 0 Then
            lStr += "R"
        Else
            lStr += " "
        End If
        If (lAttr And IO.FileAttributes.Hidden) > 0 Then
            lStr += "H"
        Else
            lStr += " "
        End If
        If (lAttr And IO.FileAttributes.System) > 0 Then
            lStr += "S"
        Else
            lStr += " "
        End If
        If (lAttr And IO.FileAttributes.Encrypted) > 0 Then
            lStr += "E"
        Else
            lStr += " "
        End If
        If (lAttr And IO.FileAttributes.NotContentIndexed) > 0 Then
            lStr += " "
        Else
            lStr += "I"
        End If
        If (lAttr And IO.FileAttributes.Compressed) > 0 Then
            lStr += "C"
        Else
            lStr += " "
        End If
        Console.WriteLine("{0} {1}", lStr, pFileName)
    End Sub
End Module
