Option Strict Off

Public Class NativeMethods

    Friend Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" (ByVal lpFileName As String, ByVal dwDesiredAccess As Integer, ByVal dwShareMode As UInteger, ByVal lpSecurityAttributes As IntPtr, ByVal dwCreationDisposition As UInteger, ByVal dwFlagsAndAttributes As UInteger, ByVal hTemplateFile As IntPtr) As IntPtr
    Friend Declare Function CloseHandle Lib "kernel32" (ByVal hObject As IntPtr) As Boolean

    Friend Declare Auto Function SetIoCompression Lib "kernel32" Alias "DeviceIoControl" (ByVal hDevice As IntPtr, ByVal dwIoControlCode As UInt32, ByRef lpInBuffer As Short, ByVal nInBufferSize As UInt32, ByVal lpOutBuffer As IntPtr, ByVal nOutBufferSize As UInt32, ByRef lpBytesReturned As UInt32, ByVal lpOverlapped As IntPtr) As Integer
    Friend Declare Auto Function GetIoCompression Lib "kernel32" Alias "DeviceIoControl" (ByVal hDevice As IntPtr, ByVal dwIoControlCode As UInt32, ByRef lpInBuffer As Short, ByVal nInBufferSize As UInt32, ByRef lpOutBuffer As Short, ByVal nOutBufferSize As UInt32, ByRef lpBytesReturned As UInt32, ByVal lpOverlapped As IntPtr) As Integer

    Friend Const GENERIC_ALL As Integer = &H10000000
    Friend Const FILE_SHARE_NONE As Integer = 0
    Friend Const FILE_SHARE_READ As Integer = 1
    Friend Const FILE_SHARE_WRITE As Integer = 2
    Friend Const OPEN_EXISTING As Integer = 3
    Friend Const FILE_READ_DATA As Integer = 1
    Friend Const FILE_WRITE_DATA As Integer = 2

    'Permet d'obtenir le handle d'un rpertoire - utilis avec CreateFile paramtre dwFlagsAndAttributes
    Friend Const FILE_FLAG_BACKUP_SEMANTICS = &H2000000

    Friend Const METHOD_NEITHER As Integer = 3
    Friend Const FILE_ANY_ACCESS As Integer = 0
    Friend Const METHOD_BUFFERED As Integer = 0
    Friend Const FILE_DEVICE_FILE_SYSTEM As Integer = &H9

    Friend Const COMPRESSION_FORMAT_NONE As Integer = 0
    Friend Const COMPRESSION_FORMAT_DEFAULT As Integer = 1
    Friend Const COMPRESSION_FORMAT_LZNT1 As Integer = 2

    Friend Shared FSCTL_GET_COMPRESSION As UInteger = CTL_CODE(FILE_DEVICE_FILE_SYSTEM, 15, METHOD_BUFFERED, FILE_ANY_ACCESS)
    Friend Shared FSCTL_SET_COMPRESSION As UInteger = CTL_CODE(FILE_DEVICE_FILE_SYSTEM, 16, METHOD_BUFFERED, FILE_READ_DATA Or FILE_WRITE_DATA)

    ''' <summary>
    ''' Traduit de la msdn en C.
    ''' </summary>
    ''' <param name="DeviceType"></param>
    ''' <param name="fct"></param>
    ''' <param name="method"></param>
    ''' <param name="access"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Private Shared Function CTL_CODE(ByVal DeviceType As UInteger, ByVal fct As UInteger, ByVal method As UInteger, ByVal access As UInteger) As UInteger

        Return ((DeviceType) << 16) Or ((access) << 14) Or ((fct) << 2) Or (method)

    End Function

End Class
